#pragma once

#include "Expr.h"
#include "ExprRep.h"
#include "RingElemRep.h"

class Integer;

class RingMapInt;
class RingMapPoly;


class IntegerRep: public RingElemRep
{
public:

	IntegerRep(void);
	virtual ~IntegerRep(void);

	IntegerRep(const IntegerRep & rhs): val(rhs.val) {
	};

	IntegerRep(const int & aval): val(aval) {
	};

	IntegerRep* clone () { 
		return new IntegerRep(*this); 
	};

	virtual void print (std::ostream& os) const;
	virtual void printRingElement(std::ostream& os, bool& issum, bool& minusleads) const;


	int getVal () {
		return val;
	};

	virtual RingElem negate();

	RingElem add(const RingElem& b);	
	RingElem mult(const RingElem& b);

	RingElem add(const Integer& b);
	RingElem mult(const Integer& b);

	RingElem add(const Polynomial& b);
	RingElem mult(const Polynomial& b);

	virtual RingElem addM(const Integer& b);
	virtual RingElem addM(const Polynomial& b);

	virtual RingElem multM(const Integer& b);
	virtual RingElem multM(const Polynomial& b);


	RingElem applyIntMap(const RingMapInt& f);
	RingElem applyPolyMap(const RingMapPoly& f);


private:

	int val;

};
