#include "StdAfx.h"
#include "Monomial.h"

#include "VarList.h"


using namespace std;

Monomial::Monomial(void)
{
}

Monomial::~Monomial(void)
{
}

void Monomial::initVec() {

	for (unsigned int i = 0; i < monvec.size(); ++i)
		monvec[i] = 0;

}

Monomial::Monomial(int len, int pos): monvec(len) { 
	
	initVec();
	monvec[pos] = 1;
}

Monomial::Monomial(int len): monvec(len) {

	initVec();

}

Monomial& Monomial::multM(const Monomial& m) {

	for (unsigned int i = 0; i < monvec.size(); ++i ) {

		monvec[i] += m.monvec[i];

	}

	return *this;

}

int Monomial::tdeg() const {

	int s = 0;
	for (unsigned int i = 0; i < monvec.size(); ++i ) {
		s += monvec[i];
	}
	return s;
}


ostream& Monomial::print(ostream& os, VarList& vl) const {

	VarList::VectorSymbol& symvec = vl.getSymList();

	MVTCI q = monvec.begin();
	MVTCI qe = monvec.end();

	VarList::VSCI p = symvec.begin();
	VarList::VSCI pe = symvec.end();

	bool empty = (q == qe);

	if (!empty)
		--qe;

	for (p = p, q = q; (p != pe) && (q != qe); ++p, ++q) {

		os << *p << "^" << *q << "*";

	};

	if (!empty)
		os << *p << "^" << *q;

	return os;

}
ostream& operator<< (ostream& os, const Monomial & mon ) {

	VarList vl(mon.size());	

	mon.print(os, vl);

	return os;

}