#pragma once

#include <vector>
#include <iostream>

class VarList;

class Monomial
{

	friend std::ostream& operator<< (std::ostream& os, const Monomial & mon );

public:

	
	typedef std::vector<int> MonVecType;
	typedef MonVecType::const_iterator MVTCI;

	~Monomial(void);
	Monomial(int len, int pos);
	Monomial(int len);

	void initVec();

	Monomial& multM(const Monomial& m);
	Monomial& setPos(int pos, int val = 1) {
		monvec[pos] = val;
		return *this;
	};
	inline int getPos (int pos) const {
		return monvec[pos];
	};
	inline unsigned int size() const {
		return monvec.size();
	};

	MonVecType& getMonVec() {
		return monvec;
	};

	int tdeg() const;

	std::ostream& print(std::ostream& os, VarList& vl) const;


protected:
	Monomial(void);

private:

	MonVecType monvec;

};

