#include "StdAfx.h"
#include "MonomialOrder.h"

#include "Monomial.h"

MonomialOrder::MonomialOrder(void)
{
}

MonomialOrder::~MonomialOrder(void)
{
}


MonCompCode MonomialOrder::cmp (const Monomial & m1, const Monomial & m2 ) {

	int d1 = m1.tdeg();
	int d2 = m2.tdeg();

	if (d1 < d2)
		return MON_LESS;
	if (d1 > d2)
		return MON_GREATER;

	if (d1 == d2) {

		for (unsigned int i = 0; i < m1.size(); ++i) {
			int a = m1.getPos(i);
			int b = m2.getPos(i);
			if (a < b)
				return MON_LESS;
			if (a > b)
				return MON_GREATER;
		}
		return MON_EQUAL;
	}

	return MON_CMP_ERROR;

};
