
#pragma once


#include "Expr.h"
#include "ReprClass.h"
#include "ExprRep.h"

#include "VarList.h"
#include "MonomialOrder.h"

#include "Symbol.h"



class RingRep;
class IntegerRingRep;
class PolynomialRingRep;




class Ring :
	public virtual Expr
{
public:

	Ring(void) {};
	~Ring(void) {};

	ENVELOPE_CLASS(Ring,RingRep)


};

class IntegerRing : public Ring {

public:

	static IntegerRing integerRing;

	IntegerRing () {};
	~IntegerRing () {};

	ENVELOPE_CLASS(IntegerRing, IntegerRingRep)

};


class PolynomialRing : public Ring {

public:

	static PolynomialRing integerRing;

	PolynomialRing () {};
	~PolynomialRing () {};

	ENVELOPE_CLASS(PolynomialRing, PolynomialRingRep)

};

bool operator== (const Ring& rA, const Ring& rB);