#pragma once
#include "exprrep.h"

class Integer;
class Polynomial;
class RingElem;

class RingMapInt;
class RingMapPoly;


class RingElemOpVirtual {};

class RingElemRep :
	public ExprRep
{
public:
	RingElemRep(void);
	virtual ~RingElemRep(void);

	virtual RingElem negate();
	virtual RingElem add(const RingElem& b);
	virtual RingElem mult(const RingElem& b);

	virtual RingElem add(const Integer& b);
	virtual RingElem mult(const Integer& b);

	virtual RingElem add(const Polynomial& b);
	virtual RingElem mult(const Polynomial& b);

	virtual RingElem addM(const Integer& b);
	virtual RingElem addM(const Polynomial& b);

	virtual RingElem multM(const Integer& b);
	virtual RingElem multM(const Polynomial& b);




	virtual RingElem applyIntMap(const RingMapInt& f);
	virtual RingElem applyPolyMap(const RingMapPoly& f);

	virtual void print(std::ostream& os) const;

	// printRingElement means printRingElement
	virtual void printRingElement(std::ostream& os, bool& issum, bool& minusleads) const; 

};
