#pragma once


#include "HashTableRep.h"
#include "Integer.h"
#include "Expr.h"
#include "IntegerRep.h"
#include "ExprRep.h"


class Type: public ExprRep
{
public:
	Type(void);
	~Type(void);

	Type(const Type& rhs);

	virtual Expr makeHashTable(const Type & valType ) const { return nil;};
//	virtual Expr makeHashTable_ZZp() const;
	virtual Expr makeHashTable_Integer() const { return nil; };
	virtual Expr makeHashTable_Expr() const { return nil; };
};


class IntegerType: public Type {

public:

static IntegerType integerType;

	IntegerType(void);
	~IntegerType(void);

	Expr makeHashTable(const Type & valType) const;

	Expr makeHashTable_Integer () const { 
		return getHashTable<Integer,Integer> ();
	}

	Expr makeHashTable_Expr () const {
		return getHashTable<Expr, Integer> ();
	}

//	HashTable<ZZp,Integer> makeHashTable_ZZp () {
//		return getHashTable<ZZpRep, IntegerRep> ();
//  };

};


/*
class ZZpType: public Type {

public:

static ZZpType zzpType;

	ZZpType(void);
	~ZZpType(void);

	Expr makeHashTable(const Type & valType) const;
	
	Expr makeHashTable_ZZp () const { 
		return getHashTable<ZZp, ZZp> ();
	}

	Expr makeHashTable_Integer () const { 
		return getHashTable<Integer, ZZp> ();
	}

	Expr makeHashTable_Expr () const {
		return getHashTable<Expr, ZZp> ();
	}

}
*/


class ExprType: public Type {

public:

static ExprType exprType;

	ExprType(void);
	~ExprType(void);

	Expr makeHashTable(const Type & valType) const ;

//	Expr makeHashTable_ZZp () { 
//		return getHashTable<ZZp, Expr> ();
//	}

	Expr makeHashTable_Integer () const {
		
		return getHashTable<Integer, Expr> ();
	}
		
	Expr makeHashTable_Expr () const {
		return getHashTable<Expr, Expr> ();
	}



};

Expr makeHashTable(const Type& keyType, const Type& valType);