#pragma once

#include <vector>

#include "Symbol.h"

class Monomial;

class VarList
{

public:

	typedef std::vector<Symbol> VectorSymbol;
	typedef VectorSymbol::const_iterator VSCI;

	VarList(int nvars, const char* anamelis[]);
	VarList(int nvars);

	~VarList(void);
	VarList(void);

	std::vector<Symbol>& getSymList () { return symlist; };
	std::ostream& print (std::ostream& os) const;

	int size () { return symlist.size(); };

	Monomial makeMonomial(const Symbol& x);

	friend bool operator== (const VarList& vl1, const VarList& vl2);

private:

	VectorSymbol symlist;

};





std::ostream& operator<< (std::ostream& os, const VarList& varLis);