#pragma once

#include <string>
#include <iostream>

#include "Expr.h"
#include "ExprRep.h"


class VariableRep: public ExprRep
{
public:

	VariableRep(void);

	VariableRep (const std::string& astring, const Expr& val = nil );

	VariableRep (const VariableRep& rhs): name(rhs.name), val(rhs.val) {
	};



	VariableRep* clone () {
		return new VariableRep(*this);
	};

	~VariableRep(void);


	Expr& operator[] (const Expr& ind);
	Expr& set ( const Expr& rhs);

	std::string getName () {
		return name;
	};

	virtual void print(std::ostream & os) const {
		os << name;
	};



private:

	std::string name;
	Expr val;

};
